(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    function filterUrl() {
        return function (request, _response, next) {
            request.url = removeLineNumberRequest(request.url);
            next();
        };
    }
    exports.default = filterUrl;
    function removeLineNumberRequest(url) {
        if (!url || url.indexOf('?') >= 0) {
            return url;
        }
        return url.split(':')[0];
    }
});
//# sourceMappingURL=filterUrl.js.map