(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "tslib", "./Coverage"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var tslib_1 = require("tslib");
    var Coverage_1 = tslib_1.__importDefault(require("./Coverage"));
    var Cobertura = (function (_super) {
        tslib_1.__extends(Cobertura, _super);
        function Cobertura(executor, options) {
            if (options === void 0) { options = {}; }
            var _this = _super.call(this, executor, options) || this;
            _this.reportType = 'cobertura';
            if (options.projectRoot) {
                _this.projectRoot = options.projectRoot;
            }
            return _this;
        }
        Cobertura.prototype.getReporterOptions = function () {
            var options = _super.prototype.getReporterOptions.call(this);
            options.projectRoot = this.projectRoot;
            return options;
        };
        return Cobertura;
    }(Coverage_1.default));
    exports.default = Cobertura;
});
//# sourceMappingURL=Cobertura.js.map