(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "tslib", "./Coverage"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var tslib_1 = require("tslib");
    var Coverage_1 = tslib_1.__importDefault(require("./Coverage"));
    var HtmlCoverage = (function (_super) {
        tslib_1.__extends(HtmlCoverage, _super);
        function HtmlCoverage(executor, options) {
            if (options === void 0) { options = {}; }
            var _this = _super.call(this, executor, options) || this;
            _this.reportType = 'html';
            if ('verbose' in options) {
                _this.verbose = options.verbose;
            }
            return _this;
        }
        HtmlCoverage.prototype.getReporterOptions = function () {
            var options = _super.prototype.getReporterOptions.call(this);
            options.verbose = this.verbose;
            return options;
        };
        return HtmlCoverage;
    }(Coverage_1.default));
    exports.default = HtmlCoverage;
});
//# sourceMappingURL=HtmlCoverage.js.map