import Coverage, { ReportType, CoverageProperties } from './Coverage';
import Node from '../executors/Node';
export default class TextCoverage extends Coverage implements TextCoverageProperties {
    readonly reportType: ReportType;
    maxColumns: number | undefined;
    constructor(executor: Node, options?: TextCoverageOptions);
    getReporterOptions(): {
        [key: string]: any;
    };
}
export interface TextCoverageProperties extends CoverageProperties {
    maxColumns?: number;
}
export declare type TextCoverageOptions = Partial<TextCoverageProperties>;
